<?php
############################################################################
# A Project of TNET Services, Inc.
############################################################################
#
#	Project:	TNET Weather Station Pages
#	Module:		Clientraw-sub.php
#	Purpose:	Subset of Clientraw functions and variables.
#
# 	Authors:	Kevin W. Reed <kreed@tnet.com>
#				TNET Services, Inc.
#
# 	Copyright:	(c) 1992-2007 Copyright TNET Services, Inc.
############################################################################
# THIS IS A MINIMAL SUBSET OF THE TNET CLIENTRAW.PHP LIBRARY
# INCLUDED TO ALLOW THIS SCRIPT TO RUN.  ONLY FUNCTIONS USED BY THE SCRIPT
# ARE INCLUDED.
############################################################################
global $SITE, $DEBUG;

// fetchUrlWithoutHanging Function
// Needs URL to fetch
// $useFopen = True to use Fopen instead
// $useFopen = False to fetch file via network
// Origination:  Comments from original source file indicate
// that the snippet came from Tom at CarterLake.  Not sure
// where he got it from or if he was the creator.

function fetchUrlWithoutHanging( $url , $useFopen ) {

	global $SITE, $DEBUG;
	
	if ($DEBUG) echo "DEBUG: Entered fetchUrlWithoutHanging with URL=[" .
		$url . "] Mode = [" . $useFopen . "]<br/>\n";
		
	// Required Items
	$numberOfSeconds = 4;		// Number of seconds to wait
	$UserAgent = $SITE['WDSUserAgent'];
	
	if ($DEBUG)	echo "DEBUG: Number of seconds [" . $numberOfSeconds . "]  UserAgent [" .
		$UserAgent . "] <br/>\n";
		
	// Are we asking to use Fopen or Fetch a URL
	
	if (! $useFopen) {
		
		if ($DEBUG)	echo "DEBUG: Using Network File Access<br/>\n";		

		// USING NETWORK FILE ACCESS TO GET FILE
		
		// Suppress error reporting so Web site 
		// visitors are unaware if the feed fails
		//error_reporting(0);

		// Extract resource path and domain from URL ready for fsockopen
		$FullUrl = $url;
		$url = str_replace("http://","",$url);
		$urlComponents = explode("/",$url);
		$domain = $urlComponents[0];
		$resourcePath = str_replace($domain,"",$url);
		
		if ($DEBUG) {
			echo "DEBUG: Attempting<br/>\n";
			echo "FullURL = [" . $FullUrl . "] URL = [" . $url . "] UrlComponents [" .
				$urlCompontents . "] Domain = [" . $domain . "] Resource Path = [" .
				$resourcePath . "]<br/>\n";
		}
		
		// Establish a connection
		
		if ($DEBUG)	echo "DEBUG: Calling Connection Open<br/>\n";	
		$socketConnection = fsockopen($domain, 80, $errno, $errstr, $numberOfSeconds);

		if (!$socketConnection) {
			if ($DEBUG) {
				echo "DEBUG: <b>ERROR WITH CONNECTION</b><br />\n";
				}
		} else {
			$xml = '';
			$req = "GET $resourcePath HTTP/1.0\r\nHost: " .
				$domain . "\r\nConnection: close\r\nUser-agent: " .
				$UserAgent . "\r\n\r\n";
			if ($DEBUG) echo "DEBUG: Sending Request of [" . $req . "]<br/>\n";
			
			fputs($socketConnection, $req );
	   		// Loop until end of file
			while (!feof($socketConnection)) {
				$rec = fgets($socketConnection, 8192);
				
				if ($DEBUG) echo "DEBUG: Obtains String [" . $rec . "]<br/>\n";
				
				$headst = substr($rec, 0, 6);
				
				if ($DEBUG) echo "DEBUG: Head of string [" . $headst . "]<br/>\n";
				
				if ( $headst == "12345 " ) {
					if ($DEBUG) echo "DEBUG: Stored Data<br/>\n";
					$xml = $rec;
				}
			}
	
			fclose ($socketConnection);
		}  
		return($xml);
 	} else {
 		
 		if ($DEBUG)	echo "DEBUG: Using Local File Access Method<br/>\n";
 		// USING FOPEN METHOD TO GET FILE
 		
 		$rawdata = array();
 		$rawdata = file($url);
 		
 		if ( empty($rawdata) ) {
 			if ($DEBUG)	echo "DEBUG: <b>NO Data found or Datafile Missing</b><br/>\n";
 			$rawdata = array("NO DATA FOUND");
 			return($rawdata);
 		} else {
 			$xml = implode (' ', $rawdata );
			return($xml);
		}
	}
}

function get_raw( $rawfile , $del, $mode ) {
	
	global $SITE;
	global $DEBUG;
	
	$rawdata = array();
	$rawinfo = array();
	
	if ($DEBUG) echo "DEBUG: Getraw with [" . $rawfile . "] delim= [" . $del . 
		"] Mode=[" . $mode . "]<br/>\n";
	
	$rawinfo = fetchUrlWithoutHanging( $rawfile , $mode );
	
	if ($DEBUG) {
		echo "DEBUG: RawInfo obtained:<pre>";
		print_r($rawinfo);
		echo "</pre><br/>\n";
		}
	$rawdata = explode ( $del, $rawinfo );
	return $rawdata;
}