<?php
//=================================================================	
// TNETWeather WDSparkline Graph Script
//=================================================================	
// Clientraw.php
// 
// Library provides WD Clientraw processing functions.
//=================================================================
global $SITE, $DEBUG;

###################################################################
# TNET Weather AutoCalls to Load all Clientraw and tag file info
###################################################################
//$SITE['wdclient']		= get_raw($SITE['hloc'] . 'clientraw.txt',' ');
//$SITE['wdclientdaily']  = get_raw($SITE['hloc'] . 'clientrawdaily.txt',' ');
//$SITE['wdclientextra']  = get_raw($SITE['hloc'] . 'clientrawextra.txt',' ');
//$SITE['wdclienthour']	= get_raw($SITE['hloc'] . 'clientrawhour.txt',' ');
//$SITE['wdtagfile']      = get_raw($SITE['hloc'] . 'weather/tagfile.php','|');
###################################################################

// fetchUrlWithoutHanging Function
// Needs URL to fetch
// $useFopen = True to use Fopen instead
// $useFopen = False to fetch file via network
// Origination:  Comments from original source file indicate
// that the snippet came from Tom at CarterLake.  Not sure
// where he got it from or if he was the creator.

function fetchUrlWithoutHanging( $url , $useFopen ) {

	global $SITE, $DEBUG;
	
	dbmsg("Entered fetchUrlWithoutHanging with URL=[" .
		$url . "] Mode = [" . $useFopen . "]");
		
	// Required Items
	$numberOfSeconds = 4;		// Number of seconds to wait
	$UserAgent = $SITE['WDSUserAgent'];
	
	dbmsg("Number of seconds [" . $numberOfSeconds . "]  UserAgent [" .
		$UserAgent . "]");
		
	// Are we asking to use Fopen or Fetch a URL
	
	if (! $useFopen) {
		
		dbmsg("Using NETWORK FILE ACCESS");

		// USING NETWORK FILE ACCESS TO GET FILE
		
		// Suppress error reporting so Web site 
		// visitors are unaware if the feed fails
		//error_reporting(0);

		// Extract resource path and domain from URL ready for fsockopen
		$FullUrl = $url;
		$url = str_replace("http://","",$url);
		$urlComponents = explode("/",$url);
		$domain = $urlComponents[0];
		$resourcePath = str_replace($domain,"",$url);
		
		dbmsg("Attempt with Paramaters:");
		dbmsg(" - FullURL = [" . $FullUrl . "]");
		dbmsg(" - URL = [" . $url . "]");
		dbmsg(" - UrlComponents [" . $urlCompontents . "]");
		dbmsg(" - Domain = [" . $domain . "]");
		dbmsg(" - Resource Path = [" . $resourcePath . "]");
		
		// Establish a connection
		
		if ($DEBUG)	echo "DEBUG: Calling Connection Open<br/>\n";	
		$socketConnection = fsockopen($domain, 80, $errno, 
			$errstr, $numberOfSeconds);

		if (!$socketConnection) {
			if ($DEBUG) {
				echo "DEBUG: <b>ERROR WITH CONNECTION</b><br />\n";
				exit;
			} else {
				// Fatal Error
				output_gfx_error ( "#006", "Network URL Failed",
					"Connection Not valid or Timed Out"); 
				exit;
			}
		} else {
			$xml = '';
			$req = "GET $resourcePath HTTP/1.0\r\nHost: " .
				$domain . "\r\nConnection: close\r\nUser-agent: " .
				$UserAgent . "\r\n\r\n";
			if ($DEBUG) echo "DEBUG: Sending Request of [" . $req . "]<br/>\n";
			
			fputs($socketConnection, $req );
	   		// Loop until end of file
			while (!feof($socketConnection)) {
				$rec = fgets($socketConnection, 8192);
				
				if ($DEBUG) echo "DEBUG: Obtains String [" . $rec . "]<br/>\n";
				
				$headst = substr($rec, 0, 6);
				
				if ($DEBUG) echo "DEBUG: Head of string [" . $headst . "]<br/>\n";
				
				if ( $headst == "12345 " ) {
					if ($DEBUG) echo "DEBUG: Stored Data<br/>\n";
					$xml = $rec;
				}
			}
			fclose ($socketConnection);
		}
		if ($xml == "" ) {
			if ($DEBUG) {
				echo "DEBUG: <b>NO Data found or Datafile Missing</b><br/>\n";
				exit;
			} else {
				// Fatal Error
				output_gfx_error ( "#008", "No Data To Plot",
					"Data file empty or not found"); 
				exit;
			}
		} 				
		return($xml);
 	} else {
 		if ($DEBUG)	echo "DEBUG: Using Local File Access Method<br/>\n";
 		// USING FOPEN METHOD TO GET FILE
 		
 		$rawdata = array();
 		$rawdata = file($url);
 		
 		if ( empty($rawdata) ) {
			if ($DEBUG) {
				echo "DEBUG: <b>NO Data found or Datafile Missing</b><br/>\n";
				exit;
			} else {
				// Fatal Error
				output_gfx_error ( "#007", "No Data To Plot",
					"Data file empty or not found"); 
				exit;
			} 			
 		} else {
 			$xml = implode (' ', $rawdata );
			return($xml);
		}
	}
}


// get_raw Function.
// Parses out information from various clientraw 
// functions to create an array of their values

function get_raw( $rawfile , $del, $mode ) {
	
	global $SITE;
	global $DEBUG;
	
	$rawdata = array();
	$rawinfo = array();
	
	if ($DEBUG) echo "DEBUG: Getraw with [" . $rawfile . "] delim= [" . $del . 
		"] Mode=[" . $mode . "]<br/>\n";
	
	$rawinfo = fetchUrlWithoutHanging( $rawfile , $mode );
	
	if ($DEBUG) {
		echo "DEBUG: RawInfo obtained:<pre>";
		print_r($rawinfo);
		echo "</pre><br/>\n";
		}
	$rawdata = explode ( $del, $rawinfo );
	return $rawdata;
}
?>
