<?php
############################################################################
# A Project of TNET Services, Inc.
############################################################################
#
#	Project:	TNET Weather Station Pages
#	Module:		Weather-math.php
#	Purpose:	Weather Related Math and Other functions
#
# 	Authors:	Kevin W. Reed <kreed@tnet.com>
#				TNET Services, Inc.
#
# 	Copyright:	(c) 1992-2007 Copyright TNET Services, Inc.
############################################################################
# THIS IS A MINIMAL SUBSET OF THE TNET WEATHER-MATH.PHP LIBRARY
# INCLUDED TO ALLOW THIS SCRIPT TO RUN.  ONLY FUNCTIONS USED BY THE SCRIPT
# ARE INCLUDED.
############################################################################
global $SITE;

############################################################################
# Returns temp in F to Percision from temp in C
############################################################################

function tempToF ($cTemp, $prec=0)
{
	if (!isset($cTemp)) {
		return false;
	}
	$prec = (integer)$prec;
	$fTemp = (float)(1.8 * $cTemp) + 32;
	return round($fTemp, $prec);
}


############################################################################
# Returns Moisture in Inches from cm
############################################################################

function cmToInch ($cm, $prec)
{
	if (!isset($cm)) {
		return false;
	}
	$prec = (integer)$prec;
	$inch = (float)$cm / 25.4;
	return round($inch, $prec);
}

############################################################################
# Returns Mph from Knots
############################################################################

function ktsToMph ($kts, $prec)
{
  if (!isset($kts)) {
    return false;
  }
  $prec = (integer)$prec;
  $inch = (float)$kts * 1.15078;
  return round($inch, $prec);
}

############################################################################
# Returns InHg32 from millibars
############################################################################

function mbToInHg32 ($mbar, $prec)
{
	if (!isset($mbar)) {
		return false;
	}
	$prec = (integer)$prec;
	$inch = (float)$mbar * 0.02953;
	return round($inch, $prec);
}